package com.zskk.service;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.util.Arrays;
import java.util.Date;
import java.util.Map;
import java.util.UUID;
import com.alibaba.fastjson.JSON;
import com.jfinal.kit.HashKit;
import com.zskk.model.Exams;
import com.zskk.model.PatientSearch;
import com.zskk.model.UserWechat;
import com.zskk.model.WechatBind;
import okhttp3.FormBody;
import okhttp3.MediaType;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;

public class UserService {

	private static final MediaType JSON_CODE = MediaType.get("application/json; charset=utf-8");

	private static final OkHttpClient OKHTTP_CLIENT = new OkHttpClient();

	/**
	 * 创建微信用户
	 * 
	 * @param openid
	 */
	public UserWechat createWxUserByGH(String openid, String gh) {
		UserWechat userWechat = new UserWechat();
		userWechat.setId(creatId());
		userWechat.setWxOpenid(openid);
		switch (gh) {

		case "gh_befaf7c0fbaf":
			userWechat.setSource("中世康恺电子胶片平台");
			break;
			
		case "gh_728267809f40":
			userWechat.setSource("测试微信");
			break;

		case "gh_c3ecc9e4d6e4":
			userWechat.setSource("黑龙江省电子胶片平台");
			break;

		case "gh_bb923a0a951e":
			userWechat.setSource("辽宁省电子胶片平台");
			break;
			
		case "gh_86f660382632":
			userWechat.setSource("河南省电子胶片平台");
			break;

		default:
			userWechat.setSource("测试微信");
			break;
		}
		userWechat.setWxIcon("");
		userWechat.setSubscribeStatus(2);
		userWechat.setCreateAt(new Date());
		userWechat.save();
		return userWechat;
	}

	/**
	 * 创建微信用户
	 * 
	 * @param openid
	 */
	public UserWechat createWxUserByAppid(String openid, String appid) {
		UserWechat user = new UserWechat();
		user.setId(creatId());
		user.setWxOpenid(openid);
		switch (appid) {

		case "wx1f3dc2c37dce641b":
			user.setSource("中世康恺电子胶片平台");
			break;
			
		case "wx6a54bf0e98ecd2c7":
			user.setSource("测试微信");
			break;

		case "wxdeb75f5d7e5a2300":
			user.setSource("黑龙江省电子胶片平台");
			break;

		case "wx2f0834870403c54e":
			user.setSource("辽宁省电子胶片平台");
			break;

		default:
			user.setSource("测试微信");
			break;
		}
		user.setWxIcon("");
		user.setSubscribeStatus(2);
		user.setCreateAt(new Date());
		user.save();
		return user;
	}

	/**
	 * 创建微信用户
	 * 
	 * @param openid
	 */
	public WechatBind bindUserReport(String uid, Exams exam) {
		WechatBind wechatBind = new WechatBind();
		wechatBind.setUserId(uid);
		wechatBind.setExamId(exam.getId());
		wechatBind.setPatientId(exam.getPatientId());
		wechatBind.setCreateAt(new Date());
		wechatBind.setBindWay(1);
		wechatBind.setStatus(1);
		wechatBind.save();
		PatientSearch patientSearch = new PatientSearch();
		patientSearch.setPatientUid(uid);
		patientSearch.setCreatedAt(new Date());
		patientSearch.setInstitutionId(exam.getInstitutionId());
		patientSearch.setSearchResult("1");
		patientSearch.setExamId(exam.getId());
		return wechatBind;
	}

	/*
	 * 获取用户信息
	 */
	public void getUserInfo(String openid) {
//		ApiConfigKit.setThreadLocalApiConfig(getApiConfig());
//		String url = String.format(GET_USERINFO, AccessTokenApi.getAccessTokenStr(), openid);
//		String content = doGet(url);
//		JSONObject obj = JSON.parseObject(content);
//		if (obj.containsKey("errcode")) {
//		} else {
//			System.out.println(obj);
//			User account = User.dao.findFirst("select * from user where wx_openid=?",openid);
//			account.setWxIcon(obj.getString("headimgurl"));
//			account.setWxNickname(obj.getString("nickname"));
//			account.update();
//		}
	}

	/*
	 * 发送模板消息
	 */
	public void sendTemplateMsg(String openid, String url, String event, String userName) {
//		if (PropKit.getBoolean("devMode") == true) {
//			ApiConfigKit.setThreadLocalApiConfig(getApiConfig());
//			SimpleDateFormat sdf = new SimpleDateFormat("yyyy年MM月dd日  HH:mm:ss");
//			String time = sdf.format(new Date());
//			String json = TemplateData.New().setTouser(openid)
//					.setTemplate_id("eNs4B9rKo_0N-sF1NRmW6PESmTLm8zi_5Vl6ujeFngA").setTopcolor("#743A3A")
//					.setUrl(url)
//					.add("keyword1", time  , "#743A3A")
//					.add("keyword2", event , "#743A3A")
//					.add("keyword3", "用药了吗？用药后感觉怎么样？快来说说吧，我们不会将您的资料泄露，完成赢积分！", "#743A3A")
//					.build();
//			System.out.println(json);
//			ApiResult result = TemplateMsgApi.send(json);
//			System.out.println(result.getJson());
//		}else{
//			ApiConfigKit.setThreadLocalApiConfig(getApiConfig());
//			SimpleDateFormat sdf = new SimpleDateFormat("yyyy年MM月dd日  HH:mm:ss");
//			String time = sdf.format(new Date());
//			String json = TemplateData.New().setTouser(openid)
//					.setTemplate_id("U4cjem6T4heIpO6gS92XE2au9ZTr0mJcgutgEoDIpRI").setTopcolor("#743A3A")
//					.setUrl(url)
//					.add("first"   , event      , "#0DB0EB")
//					.add("keyword1", userName         , "")
//					.add("keyword2", ""         , "")
//					.add("keyword3", time       , "")
//					.add("remark"  , "请按时记录哦", "#BBBBBB")
//					.build();
//			System.out.println(json);
//			ApiResult result = TemplateMsgApi.send(json);
//			System.out.println(result.getJson());
//		}
	}

	private String creatId() {
		return UUID.randomUUID().toString().replace("-", "");
	}

	private String create_timestamp() {
		return Long.toString(System.currentTimeMillis() / 1000);
	}

	private String create_nonce_str() {
		return UUID.randomUUID().toString();
	}
	
	private static String run(String url) throws IOException {
		    Request request = new Request.Builder()
		        .url(url)
		        .build();

		    try (Response response = OKHTTP_CLIENT.newCall(request).execute()) {
		      return response.body().string();
		    }
		  }
	

	private static void post2(String url, Map<String, String> map) throws IOException {
		RequestBody formBody = new FormBody.Builder()
		        .add("timestamp", String.valueOf(getSecondTimestamp(new Date())))
		        .add("signature", Ksort(map))
		        .add("data", JSON.toJSONString(map))
		        .build();
	      System.out.println(String.valueOf(getSecondTimestamp(new Date())));
	      System.out.println(Ksort(map));
	      System.out.println(JSON.toJSONString(map));

		    Request request = new Request.Builder()
		        .url("http://39.106.136.96/pacs/zskk/writePatientReport")
		        .post(formBody)
		        .build();

//		    try (Response response = OKHTTP_CLIENT.newCall(request).execute()) {
//		      if (!response.isSuccessful()) throw new IOException("Unexpected code " + response);
//
//		      System.out.println(response.body().string());
////			  return response.body().string();
//
//		    }
	  }  
	public static String getSecondTimestamp(Date date) {
        if (null == date) {
            return "参数为空";
        }
        String timestamp = String.valueOf(date.getTime());
        int length = timestamp.length();
        if (length > 3) {
            return String.valueOf(timestamp.substring(0, length - 3));
        } else {
            return "参数不足3位数";
        }
    }
	
	public static String Ksort(Map<String, String> map){
		String sb = "";
		String[] key = new String[map.size()];
		int index = 0;
		for (String k : map.keySet()) {
		key[index] = k;
		index++;
		}
		Arrays.sort(key);

		for (String s : key) {
		sb += s + "=" + map.get(s) + "&";
		}
		sb = sb.substring(0, sb.length() - 1);
		System.out.println("***"+sb);

		try {
		sb = URLEncoder.encode(sb, "UTF-8");
		} catch (UnsupportedEncodingException e) {
		e.printStackTrace();
		}// 使用常见的UTF-8编码
		sb = sb.replace("%3D", "=").replace("%26", "&");

		System.out.println("**"+sb);
		String resultString = HashKit.md5(sb+"YgpxjVeIx0yoK6Atz413IAj7hU9dygH4");
		return resultString;
	}
	

//	public static void main(String[] args) throws IOException {
////		        .url("http://wechat.pacsonline.cn/wx_patient/api/getQrcode?reportId=7e7a4cc7c93b4d2b")
//
////	    String response = run("http://www.baidu.com");
////	    System.out.println(response);
//		
//			
//		Map<String, String> data = new HashMap<String, String>();
//		//医院id
//        data.put("hospital_id","15700002");
//        //影像所见
//        data.put("description","test");
//        //意见建议
//        data.put("impression","test");
//        //检查id
//        data.put("exam_id","116f463f179cd343ooo");
//        //患者id
//        data.put("patient_id","116f463f176844f7");
//        data.put("study_id","116f463f176c89a9");
//
//        //患者姓名
//        data.put("patient_name","zhangsan");
//        //患者性别
//        data.put("patient_sex","男");
//        //身份证号
//        data.put("card_num","");
//        //手机号
//        data.put("phone","");
//        //患者生日
//        data.put("birthday","");
//        //患者检查时年龄
//        data.put("patient_age","36");
//        //阴阳性 1阴性 2阳性
//        data.put("report_result","");
//        //报告时间 10位时间戳
//        data.put("report_datetime",String.valueOf(getSecondTimestamp(new Date())));
//        //报告医生id
//        data.put("report_doctor_id","");
//        //报告医生姓名
//        data.put("report_doctor_name","lisi");
//        //审核时间
//        data.put("review_datetime",String.valueOf(getSecondTimestamp(new Date())));
//        //审核医生id
//        data.put("review_doctor_id","");
//        //审核姓名
//        data.put("review_doctor_name","lisi");
//        //确认时间
//        data.put("confirm_datetime", String.valueOf(getSecondTimestamp(new Date())));
//        //确认医生id
//        data.put("confirm_doctor_id", "");
//        //确认医生姓名
//        data.put("confirm_doctor_name","wangwu");
//		System.out.println(data);
//
//		String jString = "{\"birthdate\":\"1964-05-09 00:00:00\",\"modality\":\"MR\",\"patientid\":\"030418249\",\"patientsex\":\"女\",\"reportPaperNum\":740168,\"reportdate\":\"2020-01-08 10:33:30\",\"diagnosis\":\"宫颈ca术后\",\"accessionNumber\":\"17772\",\"patientname\":\"金淑坤\",\"symptom\":\"宫颈ca术后二年余复查\",\"clinicaldoctor\":\"郑鑫\",\"phone\":\"15946362662\",\"DESCRIPTION\":\"   盆腔呈术后改变，子宫缺如。阴道断端未见明确肿瘤信号影，增强扫描未见明显异常强化。膀胱充盈尚可，壁尚光滑。盆腔内未见明确肿大淋巴结。未见盆腔积液。左侧骶骨可见小片状异常信号影，T1WI呈低信号，T2脂肪抑制呈稍高信号，增强扫描呈轻度强化，大小约为1.0*0.4cm。\\r\\n\\r\\n\",\"printreport\":false,\"idcard\":\"231025196405090621\",\"patientage\":\"55岁\",\"impression\":\"1、盆腔呈子宫术后改变，局部未见明确复发征象，建议定期复查。\\r\\n2、左侧骶骨小片状异常强化灶，请追随。\\r\\n\",\"regPaperNum\":\"893058\",\"reviewdoctor\":\"杨滨\",\"department\":\"妇瘤一科\",\"studyuid\":\"17772\",\"printfilm\":false,\"reportdoctor\":\"刘媛\"}";
//	 Map maps = (Map)JSON.parse(jString);  
//     System.out.println("这个是用JSON类来解析JSON字符串!!!");  
//     for (Object map : maps.entrySet()){  
//         System.out.println(((Map.Entry)map).getKey()+"     " + ((Map.Entry)map).getValue());  
//     }     
//		String jsonObject = JSON.toJSONString(data);
//		System.out.println(jsonObject);
//		JSONObject record = JSON.parseObject(jString);
//		String dString  = record.getString("PATIENTAGE");
//
//		post2(null, maps);
//		
//	}
}
